#pragma once

#include "Settings.h"

//TODO: 2.0 - FILTERS - regex
//#define REGEX
#ifdef REGEX
#include "RegexCache.h"
#endif

#define MAX_INI_FILE_SIZE 128000

#define READ_INI_RECT(location,var) \
	GetPrivateProfileString(#location,#var,RectToString(&(##location.##var)),buf,sz,fn); \
	StringToRect(CString(buf),&(##location.##var));
#define WRITE_INI_RECT(location,var) \
	WritePrivateProfileString(#location,#var,RectToString(&(##location.##var)),fn);
#define PARSE_XML_RECT(location,var,xmlkey) \
	if(name.CompareNoCase(xmlkey)==0){ StringToRect(CXML::Decode(val),&(##location.##var)); }
#define WRITE_XML_RECT(location,var,xmlkey,explanation) \
	xml += XML.ToXML(xmlkey,"Text",RectToString(&(##location.##var)),RectToString(&(d.##location.##var)),explanation);

class CLogAnalysisSettings : public CSettings
{
protected:
	bool ReadFromFileINI(LPCTSTR fn);
	bool WriteToFileINI(LPCTSTR fn);
	bool WriteToFileXML(LPCTSTR fn);

	CString RectToString(RECT* rect);
	bool StringToRect(CString& strRect, RECT* rect);

public:
	void LoadDefaults();
	bool ParseXML(CString& key, CString& val);
	CString ToXML();

	virtual bool IsAllowedByFilters(CString& Line);

	//general
	class GeneralParameters{
	public:
		int SortedColumn;
		CString EOL;
		CString Separator;
		bool Trim;
		bool FirstLineHeader;
		CString WhoisServer;
		bool WordWrap;
	}General;

	//window
	class WindowParameters{
	public:
		int State;
		RECT Rect;
		RECT Splitter;
	}Window;

	//filters
	class FilterParameters{
	public:
		int MaxEntries;
		CStringList Include;
		CStringList Exclude;
		CStringList Regex;

		void Clear(){
			Include.RemoveAll();
			Exclude.RemoveAll();
			Regex.RemoveAll();
		}
	}Filter;

#ifdef REGEX
	CRegexCache regex_cache;
#endif

	CLogAnalysisSettings(void);
	virtual ~CLogAnalysisSettings(void);
};
